
ADC_CYCLES = 32;
VOLT_PER_ADCVALUE_1 = 2.56/(ADC_CYCLES*2^10);
VOLT_PER_ADCVALUE_2 = 10/(ADC_CYCLES*2^10)*1.1802;
AMPERE_PER_ADCVALUE = 6/(ADC_CYCLES*2^10)*0.8044;
SECONDS_PER_TIMECYCLE = 1;
COMPORT = 1;	% 1..8 == com1 .. com8, 0 == printerport

packet_id_last = 0;
loop_counter = 0;
tic;
while	(1)
   drawnow;   
   loop_counter = loop_counter + 1;
   
   % try to get new data 
   s = receivepacket_ser(COMPORT); 
      
   sleep(SECONDS_PER_TIMECYCLE*800);
   
   if (~isempty(s))
      packet_id = s(7);
      
      if( packet_id==81 )
      	cyclecounter = s(3)+s(4)*256;
         if ( packet_id ~= packet_id_last ) 
            cyclecounter_last = cyclecounter - 1; 
            samples_lost = 0;
            do_newfigure = 1;  
				voltage_log = [];
				cyclecounter_log = [];
				stopcounter_log = [];
				timestamp_log = [];
            packet_id_last = packet_id;
         end
         samples_lost = samples_lost + cyclecounter - cyclecounter_last - 1;
         cyclecounter_last = cyclecounter;
         
      	voltage = s(1)+s(2)*256; 
         voltage_log = [voltage_log, voltage];
         cyclecounter_log = [cyclecounter_log, cyclecounter];
         timestamp = toc;
         timestamp_log = [timestamp_log, timestamp];        
         stopcounter = s(5)+s(6)*256;
         if (stopcounter>=128*256) stopcounter = stopcounter - 256*256; end
         stopcounter_log = [stopcounter_log, stopcounter];
         
         fprintf(1,'t: %2.0f:%02.0f (min:sec), cycle: %i, voltage (ADC): %i, stopcounter: %i, samples lost: %i\n', ...
            floor(timestamp/60), floor(timestamp-60*floor(timestamp/60)), ...
            cyclecounter, voltage, stopcounter, samples_lost );
         
         if ( do_newfigure == 1 )
            figure;
				hndMyPlotWindow1 = plot( 0,0, '.-' );
				xlabel('t (minutes)');
            ylabel('U_a_c_c_u (Volt)');
            set(gcf,'Renderer', 'zbuffer');
            figure;
	  			hndMyPlotWindow2 = plot( 0,0, '.-' );
				xlabel('t (minutes)');
            ylabel('stopcounter (cycles)');
            set(gcf,'Renderer', 'zbuffer');
            do_newfigure = 0;
 		  	else
      		set( hndMyPlotWindow1, 'XData', timestamp_log/60, 'YData', voltage_log*VOLT_PER_ADCVALUE_1 );
      		set( hndMyPlotWindow2, 'XData', timestamp_log/60, 'YData', stopcounter_log );
         end
      elseif ( packet_id==80 )
         current = s(3)+s(4)*256;
         voltage = s(1)+s(2)*256;
         if ( packet_id_last ~= packet_id )
            capacity = 0;
            toc_last = toc;
            packet_id_last = packet_id;
         end
         
         toc_actual = toc;
         delta_t = toc_actual - toc_last;
         toc_last = toc_actual;
         
         capacity = capacity + current*(delta_t/3600);
         
         fprintf(1,'t: %2.0f:%02.0f (min:sec), voltage: %5.3f V, current: %4.0f mA, cumulated current: %4.0f mAh\n', ...
            floor(toc_actual/60), floor(toc_actual-60*floor(toc_actual/60)), ...
            voltage*VOLT_PER_ADCVALUE_2, current*AMPERE_PER_ADCVALUE*1000, capacity*AMPERE_PER_ADCVALUE*1000 );
     end
      
   end
      
end


